<?php

/**
 * JCH Optimize - Performs several front-end optimizations for fast downloads
 *
 * @package   jchoptimize/core
 * @author    Samuel Marshall <samuel@jch-optimize.net>
 * @copyright Copyright (c) 2023 Samuel Marshall / JCH Optimize
 * @license   GNU/GPLv3, or later. See LICENSE file
 *
 *  If LICENSE file missing, see <http://www.gnu.org/licenses/>.
 */
namespace JchOptimize\Core\Html;

use _JchOptimizeVendor\Psr\Http\Message\UriInterface;
interface HtmlElementInterface
{
    public function attribute(string $name, string $value = '', string $delimiter = '"') : \JchOptimize\Core\Html\HtmlElementInterface;
    public function hasAttribute(string $name) : bool;
    /**
     * @param string $name
     * @return string|array|UriInterface
     */
    public function attributeValue(string $name);
    public function remove($name) : \JchOptimize\Core\Html\HtmlElementInterface;
    /**
     * @param string|HtmlElementInterface $child
     * @return HtmlElementInterface
     */
    public function addChild($child) : \JchOptimize\Core\Html\HtmlElementInterface;
    public function addChildren(array $children) : \JchOptimize\Core\Html\HtmlElementInterface;
    public function hasChildren() : bool;
    public function replaceChild(int $index, $child) : \JchOptimize\Core\Html\HtmlElementInterface;
    public function render();
}
